<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="mtb__ak4954a_8c" kind="file" language="C++">
    <compoundname>mtb_ak4954a.c</compoundname>
    <includes local="no">stdbool.h</includes>
    <includes local="yes" refid="mtb__ak4954a_8h">mtb_ak4954a.h</includes>
    <incdepgraph>
      <node id="1">
        <label>stdbool.h</label>
      </node>
      <node id="0">
        <label>mtb_ak4954a.c</label>
        <link refid="mtb__ak4954a_8c" />
        <childnode refid="1" relation="include">
        </childnode>
      </node>
    </incdepgraph>
      <sectiondef kind="define">
      <memberdef id="mtb__ak4954a_8c_1a57b588a8e072d80325d844f1fbf9815b" kind="define" prot="public" static="no">
        <name>AK4954A_I2C_ADDR</name>
        <initializer>(0x12u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="28" column="9" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="28" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="var">
      <memberdef id="mtb__ak4954a_8c_1a9d88c1d94930b456b91d9a22a6493b89" kind="variable" mutable="no" prot="public" static="yes">
        <type>cyhal_i2c_t *</type>
        <definition>cyhal_i2c_t* i2c_ptr</definition>
        <argsstring />
        <name>i2c_ptr</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="30" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="30" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1a5eed1ebbc824fc36700887412d8a302a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t mtb_ak4954a_init</definition>
        <argsstring>(cyhal_i2c_t *i2c_inst)</argsstring>
        <name>mtb_ak4954a_init</name>
        <param>
          <type>cyhal_i2c_t *</type>
          <declname>i2c_inst</declname>
        </param>
        <briefdescription>
<para>Initialize the I2C communication with the audio codec and do basic configuration of the codec. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">i2c_inst</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C instance to use for communicating with the AK4954A audio codec. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if properly initialized, else an error indicating what went wrong. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="74" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="36" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="36" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1a037f19ebd8810e91485509ed92db8b4c" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_ak4954a_free</definition>
        <argsstring>(void)</argsstring>
        <name>mtb_ak4954a_free</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Frees up any resources allocated by the display as part of mtb_ak4954a_init(). </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="83" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="80" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="80" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1a5cdb3ebb5d0c8dfc50ca827aeecdfbd4" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_ak4954a_write_byte</definition>
        <argsstring>(mtb_ak4954a_reg_t reg, uint8_t data)</argsstring>
        <name>mtb_ak4954a_write_byte</name>
        <param>
          <type>mtb_ak4954a_reg_t</type>
          <declname>reg</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>data</declname>
        </param>
        <briefdescription>
<para>This function writes a data byte to an audio codec register. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">reg</parametername>
</parameternamelist>
<parameterdescription>
<para>The audio codec register to update </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">data</parametername>
</parameternamelist>
<parameterdescription>
<para>The byte to be written to the audio codec register </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="96" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="89" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="89" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1a8c2ac1a34bf6ad5caa6555f5bdbd801d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_ak4954a_reg_set</definition>
        <argsstring>(mtb_ak4954a_reg_t reg, uint8_t mask)</argsstring>
        <name>mtb_ak4954a_reg_set</name>
        <param>
          <type>mtb_ak4954a_reg_t</type>
          <declname>reg</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>mask</declname>
        </param>
        <briefdescription>
<para>This function sets bits in a register. </para>        </briefdescription>
        <detaileddescription>
<para>Only the bits set to 1 in the mask are effected.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">reg</parametername>
</parameternamelist>
<parameterdescription>
<para>The audio codec register to update </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mask</parametername>
</parameternamelist>
<parameterdescription>
<para>The mask used to set bits in the register </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="109" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="102" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="102" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1af41a0658f99dbea723b474a27f78fcd1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_ak4954a_reg_clear</definition>
        <argsstring>(mtb_ak4954a_reg_t reg, uint8_t mask)</argsstring>
        <name>mtb_ak4954a_reg_clear</name>
        <param>
          <type>mtb_ak4954a_reg_t</type>
          <declname>reg</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>mask</declname>
        </param>
        <briefdescription>
<para>This function clears bits in a register. </para>        </briefdescription>
        <detaileddescription>
<para>Only the bits set to 1 in the mask are effected.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">reg</parametername>
</parameternamelist>
<parameterdescription>
<para>The audio codec register to update </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mask</parametername>
</parameternamelist>
<parameterdescription>
<para>The mask used to clears bits in the register </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="122" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="115" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="115" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1a06eb2672ece73623043291c3846a1ff5" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_ak4954a_write_word</definition>
        <argsstring>(mtb_ak4954a_reg_t reg, uint16_t data)</argsstring>
        <name>mtb_ak4954a_write_word</name>
        <param>
          <type>mtb_ak4954a_reg_t</type>
          <declname>reg</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>data</declname>
        </param>
        <briefdescription>
<para>This function writes a data value that spans two register addresses. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">reg</parametername>
</parameternamelist>
<parameterdescription>
<para>The first of two audio codec registers to update </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">data</parametername>
</parameternamelist>
<parameterdescription>
<para>The word (16-bit) to be written to the audio codec register </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="135" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="128" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="128" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1acd413019938bca606351753a144a30f0" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_ak4954a_write_data_stream</definition>
        <argsstring>(mtb_ak4954a_reg_t reg, uint8_t *pData, uint8_t numBytes)</argsstring>
        <name>mtb_ak4954a_write_data_stream</name>
        <param>
          <type>mtb_ak4954a_reg_t</type>
          <declname>reg</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>pData</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>numBytes</declname>
        </param>
        <briefdescription>
<para>This function writes multiple data bytes to the audio codec. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">reg</parametername>
</parameternamelist>
<parameterdescription>
<para>The first audio codec register to update </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pData</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to the buffer that has data </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">numBytes</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of bytes to be written to the display controller </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="153" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="141" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="141" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1abefe432f100de6bc2c80dfa0ec71949d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_ak4954a_read_byte</definition>
        <argsstring>(mtb_ak4954a_reg_t reg, uint8_t *pData)</argsstring>
        <name>mtb_ak4954a_read_byte</name>
        <param>
          <type>mtb_ak4954a_reg_t</type>
          <declname>reg</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>pData</declname>
        </param>
        <briefdescription>
<para>This function reads a data byte from an audio codec register. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">reg</parametername>
</parameternamelist>
<parameterdescription>
<para>The audio codec register read </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pData</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to the location to store the byte read from the audio codec register </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="168" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="159" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="159" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1a1bdff68a3ce942ca9b994d7a9b3bc401" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_ak4954a_read_word</definition>
        <argsstring>(mtb_ak4954a_reg_t reg, uint16_t *pData)</argsstring>
        <name>mtb_ak4954a_read_word</name>
        <param>
          <type>mtb_ak4954a_reg_t</type>
          <declname>reg</declname>
        </param>
        <param>
          <type>uint16_t *</type>
          <declname>pData</declname>
        </param>
        <briefdescription>
<para>This function reads a data value that spans two register addresses. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">reg</parametername>
</parameternamelist>
<parameterdescription>
<para>The first of two audio codec registers to read </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pData</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to the location to store the word (16-bit) read from the audio codec register </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="183" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="174" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="174" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1ac6d3183c888ddcb7a80d8dd699d3b767" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_ak4954a_read_data_stream</definition>
        <argsstring>(mtb_ak4954a_reg_t reg, uint8_t *pData, uint8_t numBytes)</argsstring>
        <name>mtb_ak4954a_read_data_stream</name>
        <param>
          <type>mtb_ak4954a_reg_t</type>
          <declname>reg</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>pData</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>numBytes</declname>
        </param>
        <briefdescription>
<para>This function reads multiple data bytes to the audio codec. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">reg</parametername>
</parameternamelist>
<parameterdescription>
<para>The first audio codec register to read </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pData</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to the location to store the data read </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">numBytes</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of bytes to read from the display controller </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="200" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="189" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="189" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1ab7a394b71713770ba1e292ad0113e901" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void _mtb_ak4954a_init</definition>
        <argsstring>(void)</argsstring>
        <name>_mtb_ak4954a_init</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="218" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="216" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="216" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1ae3e4a8c29e7ca7ea5be9d8b54f8e3aca" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_ak4954a_adjust_volume</definition>
        <argsstring>(uint8_t volume)</argsstring>
        <name>mtb_ak4954a_adjust_volume</name>
        <param>
          <type>uint8_t</type>
          <declname>volume</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="239" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="235" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="235" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1af80216c93f807f7cd14160b1289238f1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_ak4954a_activate</definition>
        <argsstring>(void)</argsstring>
        <name>mtb_ak4954a_activate</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="261" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="252" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="252" />
      </memberdef>
      <memberdef const="no" explicit="no" id="mtb__ak4954a_8c_1a418988056c8eb3ec95fa7873cd884b59" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_ak4954a_deactivate</definition>
        <argsstring>(void)</argsstring>
        <name>mtb_ak4954a_deactivate</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="282" bodyfile="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" bodystart="275" column="1" file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" line="275" />
      </memberdef>
      </sectiondef>
    <briefdescription>
    </briefdescription>
    <detaileddescription>
    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/**************************************************************************/</highlight><highlight class="comment">/***</highlight></codeline>
<codeline lineno="2"><highlight class="comment"><sp />*<sp />\file<sp />ak4954a.c</highlight></codeline>
<codeline lineno="3"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="4"><highlight class="comment"><sp />*<sp />Description:<sp />This<sp />file<sp />contains<sp />the<sp />AK4954A<sp />codec<sp />control<sp />APIs.</highlight></codeline>
<codeline lineno="5"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="6"><highlight class="comment"><sp />*******************************************************************************</highlight></codeline>
<codeline lineno="7"><highlight class="comment"><sp />*<sp />\copyright</highlight></codeline>
<codeline lineno="8"><highlight class="comment"><sp />*<sp />Copyright<sp />2018-2020<sp />Cypress<sp />Semiconductor<sp />Corporation</highlight></codeline>
<codeline lineno="9"><highlight class="comment"><sp />*<sp />SPDX-License-Identifier:<sp />Apache-2.0</highlight></codeline>
<codeline lineno="10"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="11"><highlight class="comment"><sp />*<sp />Licensed<sp />under<sp />the<sp />Apache<sp />License,<sp />Version<sp />2.0<sp />(the<sp />"License");</highlight></codeline>
<codeline lineno="12"><highlight class="comment"><sp />*<sp />you<sp />may<sp />not<sp />use<sp />this<sp />file<sp />except<sp />in<sp />compliance<sp />with<sp />the<sp />License.</highlight></codeline>
<codeline lineno="13"><highlight class="comment"><sp />*<sp />You<sp />may<sp />obtain<sp />a<sp />copy<sp />of<sp />the<sp />License<sp />at</highlight></codeline>
<codeline lineno="14"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="15"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp />http://www.apache.org/licenses/LICENSE-2.0</highlight></codeline>
<codeline lineno="16"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="17"><highlight class="comment"><sp />*<sp />Unless<sp />required<sp />by<sp />applicable<sp />law<sp />or<sp />agreed<sp />to<sp />in<sp />writing,<sp />software</highlight></codeline>
<codeline lineno="18"><highlight class="comment"><sp />*<sp />distributed<sp />under<sp />the<sp />License<sp />is<sp />distributed<sp />on<sp />an<sp />"AS<sp />IS"<sp />BASIS,</highlight></codeline>
<codeline lineno="19"><highlight class="comment"><sp />*<sp />WITHOUT<sp />WARRANTIES<sp />OR<sp />CONDITIONS<sp />OF<sp />ANY<sp />KIND,<sp />either<sp />express<sp />or<sp />implied.</highlight></codeline>
<codeline lineno="20"><highlight class="comment"><sp />*<sp />See<sp />the<sp />License<sp />for<sp />the<sp />specific<sp />language<sp />governing<sp />permissions<sp />and</highlight></codeline>
<codeline lineno="21"><highlight class="comment"><sp />*<sp />limitations<sp />under<sp />the<sp />License.</highlight></codeline>
<codeline lineno="22"><highlight class="comment"><sp />*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="23"><highlight class="normal" /></codeline>
<codeline lineno="24"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;stdbool.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="25"><highlight class="normal" /></codeline>
<codeline lineno="26"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"mtb_ak4954a.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="27"><highlight class="normal" /></codeline>
<codeline lineno="28"><highlight class="normal" /><highlight class="preprocessor">#define<sp />AK4954A_I2C_ADDR<sp /><sp />(0x12u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="29"><highlight class="normal" /></codeline>
<codeline lineno="30"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />cyhal_i2c_t<sp />*i2c_ptr;</highlight></codeline>
<codeline lineno="31"><highlight class="normal" /></codeline>
<codeline lineno="32"><highlight class="normal" /></codeline>
<codeline lineno="33"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="34"><highlight class="comment"><sp />*<sp />Initialize<sp />the<sp />Audio<sp />codec.</highlight></codeline>
<codeline lineno="35"><highlight class="comment"><sp />*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="36"><highlight class="normal">cy_rslt_t<sp />mtb_ak4954a_init(cyhal_i2c_t<sp />*i2c_inst)</highlight></codeline>
<codeline lineno="37"><highlight class="normal">{</highlight></codeline>
<codeline lineno="38"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(i2c_inst<sp />==<sp />NULL)</highlight></codeline>
<codeline lineno="39"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />CY_RSLT_AK4954A_INIT_FAIL;</highlight></codeline>
<codeline lineno="40"><highlight class="normal" /></codeline>
<codeline lineno="41"><highlight class="normal"><sp /><sp /><sp /><sp />i2c_ptr<sp />=<sp />i2c_inst;</highlight></codeline>
<codeline lineno="42"><highlight class="normal" /></codeline>
<codeline lineno="43"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />From<sp />the<sp />AK4954A<sp />spec:</highlight></codeline>
<codeline lineno="44"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />Upon<sp />power-up,<sp />the<sp />AK4954A<sp />must<sp />be<sp />reset<sp />by<sp />bringing<sp />the<sp />PDN<sp />pin<sp />=<sp />"L".<sp />This<sp />reset<sp />is</highlight></codeline>
<codeline lineno="45"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />released<sp />when<sp />a<sp />dummy<sp />command<sp />is<sp />input<sp />after<sp />the<sp />PDN<sp />pin<sp />=<sp />"H".<sp />This<sp />ensures<sp />that<sp />all</highlight></codeline>
<codeline lineno="46"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />internal<sp />registers<sp />reset<sp />to<sp />their<sp />initial<sp />value.<sp />This<sp />reset<sp />is<sp />released<sp />when<sp />the<sp />dummy</highlight></codeline>
<codeline lineno="47"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />command<sp />(Actually,<sp />the<sp />rising<sp />edge<sp />of<sp />16th<sp />SCL)<sp />is<sp />input<sp />after<sp />PDN<sp />pin<sp />=<sp />"H".<sp />Dummy</highlight></codeline>
<codeline lineno="48"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />command<sp />is<sp />executed<sp />by<sp />writing<sp />all<sp />"0"<sp />to<sp />the<sp />register<sp />address<sp />00H.<sp />It<sp />is<sp />recommended</highlight></codeline>
<codeline lineno="49"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />to<sp />set<sp />the<sp />PDN<sp />pin<sp />=<sp />"L"<sp />before<sp />power<sp />up<sp />the<sp />AK4954A.</highlight></codeline>
<codeline lineno="50"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="51"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />We<sp />don't<sp />want<sp />to<sp />call<sp />mtb_ak4954a_write_byte()<sp />here<sp />because<sp />we<sp />will<sp />hang<sp />on<sp />the</highlight></codeline>
<codeline lineno="52"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />CY_ASSERT()<sp />check.<sp /><sp />The<sp />second<sp />call<sp />to<sp />cyhal_i2c_master_write()<sp />is<sp />needed<sp />to<sp />clean<sp />up</highlight></codeline>
<codeline lineno="53"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />the<sp />error<sp />that<sp />occurs<sp />with<sp />the<sp />first<sp />one.</highlight></codeline>
<codeline lineno="54"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="55"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="56"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp />buf[]<sp />=<sp />{AK4954A_REG_PWR_MGMT1,<sp />0};</highlight></codeline>
<codeline lineno="57"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_i2c_master_write(i2c_ptr,<sp />AK4954A_I2C_ADDR,<sp />buf,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(buf),<sp />0,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="58"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_i2c_master_write(i2c_ptr,<sp />AK4954A_I2C_ADDR,<sp />buf,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(buf),<sp />0,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="59"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="60"><highlight class="normal" /></codeline>
<codeline lineno="61"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Clear<sp />Power<sp />Managament<sp />1<sp />register<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="62"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_write_byte(AK4954A_REG_PWR_MGMT1,<sp />0x00);</highlight></codeline>
<codeline lineno="63"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="64"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />data<sp />alignment<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="65"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_write_byte(AK4954A_REG_MODE_CTRL1,<sp />AK4954A_DEF_DATA_ALIGNMENT);</highlight></codeline>
<codeline lineno="66"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="67"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />sample<sp />rate<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="68"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_write_byte(AK4954A_REG_MODE_CTRL2,<sp />AK4954A_DEF_SAMPLING_RATE);</highlight></codeline>
<codeline lineno="69"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="70"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Clear<sp />Digital<sp />Filter<sp />Mode<sp />register<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="71"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_write_byte(AK4954A_REG_DIG_FLTR_MODE,<sp />0x00);</highlight></codeline>
<codeline lineno="72"><highlight class="normal" /></codeline>
<codeline lineno="73"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />CY_RSLT_SUCCESS;</highlight></codeline>
<codeline lineno="74"><highlight class="normal">}</highlight></codeline>
<codeline lineno="75"><highlight class="normal" /></codeline>
<codeline lineno="76"><highlight class="normal" /></codeline>
<codeline lineno="77"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="78"><highlight class="comment"><sp />*<sp />Free<sp />the<sp />resources<sp />used<sp />with<sp />the<sp />Audio<sp />codec.</highlight></codeline>
<codeline lineno="79"><highlight class="comment"><sp />*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="80"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mtb_ak4954a_free(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="81"><highlight class="normal">{</highlight></codeline>
<codeline lineno="82"><highlight class="normal"><sp /><sp /><sp /><sp />i2c_ptr<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="83"><highlight class="normal">}</highlight></codeline>
<codeline lineno="84"><highlight class="normal" /></codeline>
<codeline lineno="85"><highlight class="normal" /></codeline>
<codeline lineno="86"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="87"><highlight class="comment"><sp />*<sp />This<sp />function<sp />writes<sp />a<sp />data<sp />byte<sp />to<sp />an<sp />audio<sp />codec<sp />register</highlight></codeline>
<codeline lineno="88"><highlight class="comment"><sp />*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="89"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mtb_ak4954a_write_byte(mtb_ak4954a_reg_t<sp />reg,<sp />uint8_t<sp />data)</highlight></codeline>
<codeline lineno="90"><highlight class="normal">{</highlight></codeline>
<codeline lineno="91"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />rslt;</highlight></codeline>
<codeline lineno="92"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />buf[]<sp />=<sp />{reg,<sp />data};</highlight></codeline>
<codeline lineno="93"><highlight class="normal" /></codeline>
<codeline lineno="94"><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp />cyhal_i2c_master_write(i2c_ptr,<sp />AK4954A_I2C_ADDR,<sp />buf,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(buf),<sp />0,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="95"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />rslt);</highlight></codeline>
<codeline lineno="96"><highlight class="normal">}</highlight></codeline>
<codeline lineno="97"><highlight class="normal" /></codeline>
<codeline lineno="98"><highlight class="normal" /></codeline>
<codeline lineno="99"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="100"><highlight class="comment"><sp />*<sp />This<sp />function<sp />sets<sp />bits<sp />in<sp />a<sp />register.</highlight></codeline>
<codeline lineno="101"><highlight class="comment"><sp />*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="102"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mtb_ak4954a_reg_set(mtb_ak4954a_reg_t<sp />reg,<sp />uint8_t<sp />mask)</highlight></codeline>
<codeline lineno="103"><highlight class="normal">{</highlight></codeline>
<codeline lineno="104"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />data;</highlight></codeline>
<codeline lineno="105"><highlight class="normal" /></codeline>
<codeline lineno="106"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_read_byte(reg,<sp />&amp;data);</highlight></codeline>
<codeline lineno="107"><highlight class="normal"><sp /><sp /><sp /><sp />data<sp />|=<sp />mask;</highlight></codeline>
<codeline lineno="108"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_write_byte(reg,<sp />data);</highlight></codeline>
<codeline lineno="109"><highlight class="normal">}</highlight></codeline>
<codeline lineno="110"><highlight class="normal" /></codeline>
<codeline lineno="111"><highlight class="normal" /></codeline>
<codeline lineno="112"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="113"><highlight class="comment"><sp />*<sp />This<sp />function<sp />clears<sp />bits<sp />in<sp />a<sp />register.</highlight></codeline>
<codeline lineno="114"><highlight class="comment"><sp />*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="115"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mtb_ak4954a_reg_clear(mtb_ak4954a_reg_t<sp />reg,<sp />uint8_t<sp />mask)</highlight></codeline>
<codeline lineno="116"><highlight class="normal">{</highlight></codeline>
<codeline lineno="117"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />data;</highlight></codeline>
<codeline lineno="118"><highlight class="normal" /></codeline>
<codeline lineno="119"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_read_byte(reg,<sp />&amp;data);</highlight></codeline>
<codeline lineno="120"><highlight class="normal"><sp /><sp /><sp /><sp />data<sp />&amp;=<sp />~mask;</highlight></codeline>
<codeline lineno="121"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_write_byte(reg,<sp />data);</highlight></codeline>
<codeline lineno="122"><highlight class="normal">}</highlight></codeline>
<codeline lineno="123"><highlight class="normal" /></codeline>
<codeline lineno="124"><highlight class="normal" /></codeline>
<codeline lineno="125"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="126"><highlight class="comment"><sp />*<sp />This<sp />function<sp />writes<sp />a<sp />data<sp />value<sp />that<sp />spans<sp />two<sp />register<sp />addresses</highlight></codeline>
<codeline lineno="127"><highlight class="comment"><sp />*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="128"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mtb_ak4954a_write_word(mtb_ak4954a_reg_t<sp />reg,<sp />uint16_t<sp />data)</highlight></codeline>
<codeline lineno="129"><highlight class="normal">{</highlight></codeline>
<codeline lineno="130"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />rslt;</highlight></codeline>
<codeline lineno="131"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />buf[]<sp />=<sp />{reg,<sp />((uint8_t*)&amp;data)[0],<sp />((uint8_t*)&amp;data)[1]};</highlight></codeline>
<codeline lineno="132"><highlight class="normal" /></codeline>
<codeline lineno="133"><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp />cyhal_i2c_master_write(i2c_ptr,<sp />AK4954A_I2C_ADDR,<sp />buf,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(buf),<sp />0,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="134"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />rslt);</highlight></codeline>
<codeline lineno="135"><highlight class="normal">}</highlight></codeline>
<codeline lineno="136"><highlight class="normal" /></codeline>
<codeline lineno="137"><highlight class="normal" /></codeline>
<codeline lineno="138"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="139"><highlight class="comment"><sp />*<sp />This<sp />function<sp />writes<sp />multiple<sp />data<sp />bytes<sp />to<sp />the<sp />audio<sp />codec</highlight></codeline>
<codeline lineno="140"><highlight class="comment"><sp />*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="141"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mtb_ak4954a_write_data_stream(mtb_ak4954a_reg_t<sp />reg,<sp />uint8_t<sp />*pData,<sp />uint8_t<sp />numBytes)</highlight></codeline>
<codeline lineno="142"><highlight class="normal">{</highlight></codeline>
<codeline lineno="143"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(numBytes<sp />&lt;=<sp />AK4954A_REG_MAX_ADDRESS);</highlight></codeline>
<codeline lineno="144"><highlight class="normal" /></codeline>
<codeline lineno="145"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />rslt;</highlight></codeline>
<codeline lineno="146"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />buf[AK4954A_REG_MAX_ADDRESS<sp />+<sp />1];</highlight></codeline>
<codeline lineno="147"><highlight class="normal" /></codeline>
<codeline lineno="148"><highlight class="normal"><sp /><sp /><sp /><sp />buf[0]<sp />=<sp />reg;</highlight></codeline>
<codeline lineno="149"><highlight class="normal"><sp /><sp /><sp /><sp />memcpy(&amp;buf[1],<sp />pData,<sp />numBytes);</highlight></codeline>
<codeline lineno="150"><highlight class="normal" /></codeline>
<codeline lineno="151"><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp />cyhal_i2c_master_write(i2c_ptr,<sp />AK4954A_I2C_ADDR,<sp />buf,<sp />numBytes<sp />+<sp />1,<sp />0,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="152"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />rslt);</highlight></codeline>
<codeline lineno="153"><highlight class="normal">}</highlight></codeline>
<codeline lineno="154"><highlight class="normal" /></codeline>
<codeline lineno="155"><highlight class="normal" /></codeline>
<codeline lineno="156"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="157"><highlight class="comment"><sp />*<sp />This<sp />function<sp />reads<sp />a<sp />data<sp />byte<sp />from<sp />an<sp />audio<sp />codec<sp />register</highlight></codeline>
<codeline lineno="158"><highlight class="comment"><sp />*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="159"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mtb_ak4954a_read_byte(mtb_ak4954a_reg_t<sp />reg,<sp />uint8_t<sp />*pData)</highlight></codeline>
<codeline lineno="160"><highlight class="normal">{</highlight></codeline>
<codeline lineno="161"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />rslt;</highlight></codeline>
<codeline lineno="162"><highlight class="normal" /></codeline>
<codeline lineno="163"><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp />cyhal_i2c_master_write(i2c_ptr,<sp />AK4954A_I2C_ADDR,<sp />(uint8_t*)(&amp;reg),<sp />1,<sp />0,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="164"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />rslt);</highlight></codeline>
<codeline lineno="165"><highlight class="normal" /></codeline>
<codeline lineno="166"><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp />cyhal_i2c_master_read(i2c_ptr,<sp />AK4954A_I2C_ADDR,<sp />pData,<sp />1,<sp />0,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="167"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />rslt);</highlight></codeline>
<codeline lineno="168"><highlight class="normal">}</highlight></codeline>
<codeline lineno="169"><highlight class="normal" /></codeline>
<codeline lineno="170"><highlight class="normal" /></codeline>
<codeline lineno="171"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="172"><highlight class="comment"><sp />*<sp />This<sp />function<sp />reads<sp />a<sp />data<sp />value<sp />that<sp />spans<sp />two<sp />register<sp />addresses</highlight></codeline>
<codeline lineno="173"><highlight class="comment"><sp />*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="174"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mtb_ak4954a_read_word(mtb_ak4954a_reg_t<sp />reg,<sp />uint16_t<sp />*pData)</highlight></codeline>
<codeline lineno="175"><highlight class="normal">{</highlight></codeline>
<codeline lineno="176"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />rslt;</highlight></codeline>
<codeline lineno="177"><highlight class="normal" /></codeline>
<codeline lineno="178"><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp />cyhal_i2c_master_write(i2c_ptr,<sp />AK4954A_I2C_ADDR,<sp />(uint8_t*)(&amp;reg),<sp />1,<sp />0,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="179"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />rslt);</highlight></codeline>
<codeline lineno="180"><highlight class="normal" /></codeline>
<codeline lineno="181"><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp />cyhal_i2c_master_read(i2c_ptr,<sp />AK4954A_I2C_ADDR,<sp />(uint8_t*)pData,<sp />2,<sp />0,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="182"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />rslt);</highlight></codeline>
<codeline lineno="183"><highlight class="normal">}</highlight></codeline>
<codeline lineno="184"><highlight class="normal" /></codeline>
<codeline lineno="185"><highlight class="normal" /></codeline>
<codeline lineno="186"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="187"><highlight class="comment"><sp />*<sp />This<sp />function<sp />reads<sp />multiple<sp />data<sp />bytes<sp />from<sp />the<sp />audio<sp />codec</highlight></codeline>
<codeline lineno="188"><highlight class="comment"><sp />*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="189"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mtb_ak4954a_read_data_stream(mtb_ak4954a_reg_t<sp />reg,<sp />uint8_t<sp />*pData,<sp />uint8_t<sp />numBytes)</highlight></codeline>
<codeline lineno="190"><highlight class="normal">{</highlight></codeline>
<codeline lineno="191"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(numBytes<sp />&lt;=<sp />AK4954A_REG_MAX_ADDRESS);</highlight></codeline>
<codeline lineno="192"><highlight class="normal" /></codeline>
<codeline lineno="193"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />rslt;</highlight></codeline>
<codeline lineno="194"><highlight class="normal" /></codeline>
<codeline lineno="195"><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp />cyhal_i2c_master_write(i2c_ptr,<sp />AK4954A_I2C_ADDR,<sp />(uint8_t*)(&amp;reg),<sp />1,<sp />0,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="196"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />rslt);</highlight></codeline>
<codeline lineno="197"><highlight class="normal" /></codeline>
<codeline lineno="198"><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp />cyhal_i2c_master_read(i2c_ptr,<sp />AK4954A_I2C_ADDR,<sp />pData,<sp />numBytes,<sp />0,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="199"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />rslt);</highlight></codeline>
<codeline lineno="200"><highlight class="normal">}</highlight></codeline>
<codeline lineno="201"><highlight class="normal" /></codeline>
<codeline lineno="202"><highlight class="normal" /></codeline>
<codeline lineno="203"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="204"><highlight class="comment">*<sp />Function<sp />Name:<sp />ak4954a_init</highlight></codeline>
<codeline lineno="205"><highlight class="comment">********************************************************************************</highlight></codeline>
<codeline lineno="206"><highlight class="comment">*<sp />Summary:</highlight></codeline>
<codeline lineno="207"><highlight class="comment">*<sp /><sp /><sp />Initializes<sp />the<sp />codec<sp />with<sp />default<sp />settings.</highlight></codeline>
<codeline lineno="208"><highlight class="comment">*</highlight></codeline>
<codeline lineno="209"><highlight class="comment">*<sp />Parameters:<sp /><sp /></highlight></codeline>
<codeline lineno="210"><highlight class="comment">*<sp /><sp /><sp />None</highlight></codeline>
<codeline lineno="211"><highlight class="comment">*</highlight></codeline>
<codeline lineno="212"><highlight class="comment">*<sp />Return:</highlight></codeline>
<codeline lineno="213"><highlight class="comment">*<sp /><sp /><sp />uint32_t<sp />-<sp />I2C<sp />master<sp />transaction<sp />error<sp />status<sp /></highlight></codeline>
<codeline lineno="214"><highlight class="comment">*</highlight></codeline>
<codeline lineno="215"><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="216"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />_mtb_ak4954a_init(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="217"><highlight class="normal">{</highlight></codeline>
<codeline lineno="218"><highlight class="normal">}</highlight></codeline>
<codeline lineno="219"><highlight class="normal" /></codeline>
<codeline lineno="220"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="221"><highlight class="comment">*<sp />Function<sp />Name:<sp />ak4954a_adjust_volume</highlight></codeline>
<codeline lineno="222"><highlight class="comment">********************************************************************************</highlight></codeline>
<codeline lineno="223"><highlight class="comment">*<sp />Summary:</highlight></codeline>
<codeline lineno="224"><highlight class="comment">*<sp /><sp /><sp />This<sp />function<sp />updates<sp />the<sp />volume<sp />of<sp />both<sp />the<sp />left<sp />and<sp />right<sp />channels<sp />of<sp />the</highlight></codeline>
<codeline lineno="225"><highlight class="comment">*<sp /><sp /><sp />headphone<sp />output.</highlight></codeline>
<codeline lineno="226"><highlight class="comment">*</highlight></codeline>
<codeline lineno="227"><highlight class="comment">*</highlight></codeline>
<codeline lineno="228"><highlight class="comment">*<sp />Parameters:<sp /><sp /></highlight></codeline>
<codeline lineno="229"><highlight class="comment">*<sp /><sp /><sp />volume<sp />-<sp />Steps<sp />of<sp />0.5dB,<sp />where:</highlight></codeline>
<codeline lineno="230"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Minimum<sp />volume:<sp />-65.5dB<sp />(0x8F)</highlight></codeline>
<codeline lineno="231"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Maximum<sp />volume:<sp /><sp />+6.0dB<sp />(0x00)</highlight></codeline>
<codeline lineno="232"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Mute:<sp />(0x90~0xFF)</highlight></codeline>
<codeline lineno="233"><highlight class="comment">*</highlight></codeline>
<codeline lineno="234"><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="235"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mtb_ak4954a_adjust_volume(uint8_t<sp />volume)</highlight></codeline>
<codeline lineno="236"><highlight class="normal">{</highlight></codeline>
<codeline lineno="237"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_write_byte(AK4954A_REG_LCH_DIG_VOL_CTRL,<sp />volume);</highlight></codeline>
<codeline lineno="238"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_write_byte(AK4954A_REG_RCH_DIG_VOL_CTRL,<sp />volume);</highlight></codeline>
<codeline lineno="239"><highlight class="normal">}</highlight></codeline>
<codeline lineno="240"><highlight class="normal" /></codeline>
<codeline lineno="241"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="242"><highlight class="comment">*<sp />Function<sp />Name:<sp />ak4954a_activate</highlight></codeline>
<codeline lineno="243"><highlight class="comment">********************************************************************************</highlight></codeline>
<codeline lineno="244"><highlight class="comment">*<sp />Summary:</highlight></codeline>
<codeline lineno="245"><highlight class="comment">*<sp /><sp /><sp />Activates<sp />the<sp />codec<sp />-<sp />This<sp />function<sp />is<sp />called<sp />in<sp />conjunction<sp />with<sp /></highlight></codeline>
<codeline lineno="246"><highlight class="comment">*<sp /><sp /><sp />ak4954A_deactivate<sp />API<sp />after<sp />successful<sp />configuration<sp />update<sp />of<sp />the<sp />codec.</highlight></codeline>
<codeline lineno="247"><highlight class="comment">*</highlight></codeline>
<codeline lineno="248"><highlight class="comment">*<sp />Parameters:<sp /><sp /></highlight></codeline>
<codeline lineno="249"><highlight class="comment">*<sp /><sp /><sp />None</highlight></codeline>
<codeline lineno="250"><highlight class="comment">*</highlight></codeline>
<codeline lineno="251"><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="252"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mtb_ak4954a_activate(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="253"><highlight class="normal">{</highlight></codeline>
<codeline lineno="254"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />Power<sp />Management<sp />DAC<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="255"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_write_byte(AK4954A_REG_PWR_MGMT1,<sp /></highlight></codeline>
<codeline lineno="256"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />AK4954A_PWR_MGMT1_PMDAC<sp />|<sp />AK4954A_PWR_MGMT1_PMVCM);</highlight></codeline>
<codeline lineno="257"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="258"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />Left/Right<sp />Channels<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="259"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_write_byte(AK4954A_REG_PWR_MGMT2,<sp /></highlight></codeline>
<codeline lineno="260"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />AK4954A_PWR_MGMT2_PMHPL<sp />|<sp />AK4954A_PWR_MGMT2_PMHPR);</highlight></codeline>
<codeline lineno="261"><highlight class="normal">}</highlight></codeline>
<codeline lineno="262"><highlight class="normal" /></codeline>
<codeline lineno="263"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="264"><highlight class="comment">*<sp />Function<sp />Name:<sp />ak4954a_deactivate</highlight></codeline>
<codeline lineno="265"><highlight class="comment">********************************************************************************</highlight></codeline>
<codeline lineno="266"><highlight class="comment">*<sp />Summary:</highlight></codeline>
<codeline lineno="267"><highlight class="comment">*<sp /><sp /><sp />Deactivates<sp />the<sp />codec<sp />-<sp />the<sp />configuration<sp />is<sp />retained,<sp />just<sp />the<sp />codec<sp /></highlight></codeline>
<codeline lineno="268"><highlight class="comment">*<sp /><sp /><sp />input/outputs<sp />are<sp />disabled.<sp />The<sp />function<sp />should<sp />be<sp />called<sp />before<sp />changing<sp /></highlight></codeline>
<codeline lineno="269"><highlight class="comment">*<sp /><sp /><sp />any<sp />setting<sp />in<sp />the<sp />codec<sp />over<sp />I2C</highlight></codeline>
<codeline lineno="270"><highlight class="comment">*</highlight></codeline>
<codeline lineno="271"><highlight class="comment">*<sp />Parameters:<sp /><sp /></highlight></codeline>
<codeline lineno="272"><highlight class="comment">*<sp /><sp /><sp />None</highlight></codeline>
<codeline lineno="273"><highlight class="comment">*</highlight></codeline>
<codeline lineno="274"><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="275"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />mtb_ak4954a_deactivate(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="276"><highlight class="normal">{</highlight></codeline>
<codeline lineno="277"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Disable<sp />Left/Right<sp />Channels<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="278"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_write_byte(AK4954A_REG_PWR_MGMT2,<sp />0x00);</highlight></codeline>
<codeline lineno="279"><highlight class="normal" /></codeline>
<codeline lineno="280"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Disable<sp />Power<sp />Management<sp />DAC<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="281"><highlight class="normal"><sp /><sp /><sp /><sp />mtb_ak4954a_write_byte(AK4954A_REG_PWR_MGMT1,<sp />AK4954A_PWR_MGMT1_PMVCM);</highlight></codeline>
<codeline lineno="282"><highlight class="normal">}</highlight></codeline>
<codeline lineno="283"><highlight class="normal" /></codeline>
<codeline lineno="284"><highlight class="normal" /><highlight class="comment">/*<sp />[]<sp />END<sp />OF<sp />FILE<sp />*/</highlight><highlight class="normal" /></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_AK4954A/audio-codec-ak4954a/mtb_ak4954a.c" />
  </compounddef>
</doxygen>